// Copyright (c) 2018 Victorien Elvinger
//
// Licensed under the zlib license (https://opensource.org/licenses/zlib).
//
// This file is part of replayable-random
// (https://github.com/Conaclos/replayable-random)
/**
 * Example:
 * Given `x: unknown`
 * `isObject<{ p: number }>(x) && typeof x.p === "number"`
 * enables to test if x is conforms to `{ p: number }`.
 *
 * @internal
 * @param x
 * @param Is `x' a non-null object?
 */
export const isObject = (x) => typeof x === "object" && x !== null;
export function fromArray(x, f) {
    let result = new Array(x.length);
    let i = 0;
    while (result !== undefined && i < x.length) {
        const o = f(x[i]);
        if (o === undefined) {
            result = undefined;
        }
        else {
            result[i] = o;
            i++;
        }
    }
    return result;
}
export function or(f, g) {
    return (x) => {
        const a = f(x);
        if (a !== undefined) {
            return a;
        }
        return g(x);
    };
}
//# sourceMappingURL=data-validation.js.map