import test from "ava";
import { U32Range } from "../../src/core/u32-range";
function twiInterval(ref) {
    return U32Range.fromLength(ref.lower, ref.length);
}
const from0to1 = U32Range.fromLength(0, 2);
const from1to2 = U32Range.fromLength(1, 2);
const from0to2 = U32Range.fromLength(0, 3);
const singleton0 = U32Range.fromLength(0, 1);
const singleton1 = U32Range.fromLength(1, 1);
const singleton2 = U32Range.fromLength(2, 1);
test("from-bounds", (t) => {
    t.deepEqual(U32Range.fromBounds(0, 1), from0to1);
});
test("a-compare", (t) => {
    t.is(singleton0.compare(twiInterval(singleton0)), 0 /* EQUAL */);
    t.is(singleton0.compare(from1to2), -5 /* PREPENDABLE */);
    t.is(from1to2.compare(singleton0), 5 /* APPENDABLE */);
    t.is(singleton0.compare(singleton2), -6 /* BEFORE */);
    t.is(singleton2.compare(singleton0), 6 /* AFTER */);
    t.is(from0to1.compare(from1to2), -4 /* OVERLAPPING_BEFORE */);
    t.is(from1to2.compare(from0to1), 4 /* OVERLAPPING_AFTER */);
    t.is(from0to1.compare(singleton0), 1 /* INCLUDING_LEFT */);
    t.is(singleton0.compare(from0to1), -3 /* INCLUDED_LEFT_BY */);
    t.is(from0to1.compare(singleton1), 3 /* INCLUDING_RIGHT */);
    t.is(singleton1.compare(from0to1), -1 /* INCLUDED_RIGHT_BY */);
    t.is(from0to2.compare(singleton1), 2 /* INCLUDING_MIDDLE */);
    t.is(singleton1.compare(from0to2), -2 /* INCLUDED_MIDDLE_BY */);
});
test("append", (t) => {
    t.deepEqual(singleton0.append(singleton1), from0to1);
});
//# sourceMappingURL=u32-range.test.js.map