import test from "ava";
import { twinPositionPart } from "./pos.testutil";
import { SimplePosPart } from "../../../src/pos/simple/simple-pos-part";
const part1001 = SimplePosPart.from(1, 0, 0, 1);
const part1110 = SimplePosPart.from(1, 0, 1, 0);
const part1100 = SimplePosPart.from(1, 1, 0, 0);
const part2000 = SimplePosPart.from(2, 0, 0, 0);
test("asTuple", (t) => {
    const a = 1;
    const b = 2;
    const c = 3;
    const d = 4;
    t.deepEqual(SimplePosPart.from(a, b, c, d).asTuple(), [a, b, c, 4]);
});
test("with-offset", (t) => {
    t.deepEqual(part1001.withOffset(5), SimplePosPart.from(1, 0, 0, 5));
});
test("compare", (t) => {
    // reflexivity
    t.is(part1001.compare(twinPositionPart(part1001)), 0 /* EQUAL */);
    t.is(part1110.compare(twinPositionPart(part1110)), 0 /* EQUAL */);
    t.is(part1100.compare(twinPositionPart(part1100)), 0 /* EQUAL */);
    t.is(part2000.compare(twinPositionPart(part2000)), 0 /* EQUAL */);
    t.is(part1001.compare(part1001.withOffset(5)), -1 /* BEFORE */);
    t.is(part1100.compare(part1100.withOffset(5)), -1 /* BEFORE */);
    t.is(part1001.compare(part1110), -1 /* BEFORE */);
    t.is(part1110.compare(part1100), -1 /* BEFORE */);
    t.is(part1100.compare(part2000), -1 /* BEFORE */);
    t.is(part1110.compare(part1001), 1 /* AFTER */);
    t.is(part1100.compare(part1110), 1 /* AFTER */);
    t.is(part2000.compare(part1100), 1 /* AFTER */);
});
test("compareBase", (t) => {
    // reflexivity
    t.is(part1001.compareBase(twinPositionPart(part1001)), 0 /* EQUAL */);
    t.is(part1100.compareBase(twinPositionPart(part1100)), 0 /* EQUAL */);
    t.is(part2000.compareBase(twinPositionPart(part2000)), 0 /* EQUAL */);
    t.is(part1001.compareBase(part1001.withOffset(5)), 0 /* EQUAL */);
    t.is(part1100.compareBase(part1100.withOffset(5)), 0 /* EQUAL */);
    t.is(part1001.compareBase(part1110), -1 /* BEFORE */);
    t.is(part1110.compareBase(part1100), -1 /* BEFORE */);
    t.is(part1100.compareBase(part2000), -1 /* BEFORE */);
    t.is(part1110.compareBase(part1001), 1 /* AFTER */);
    t.is(part1100.compareBase(part1110), 1 /* AFTER */);
    t.is(part2000.compareBase(part1100), 1 /* AFTER */);
});
test("from-plain", (t) => {
    t.is(SimplePosPart.fromPlain(undefined), undefined);
    t.deepEqual(SimplePosPart.fromPlain(part1001), part1001);
});
//# sourceMappingURL=simple-dot-pos-part.test.js.map