import test from "ava";
import { lexCompareOrdering, orderingInversion, } from "../../src/util/ordering";
const ORDERING_VALUES = [-1 /* BEFORE */, 0 /* EQUAL */, 1 /* AFTER */];
test("lexCompareOrdering_neutral-element", (t) => {
    for (const o of ORDERING_VALUES) {
        t.is(lexCompareOrdering(0 /* EQUAL */, o), o);
    }
});
test("lexCompareOrdering_lex-priority", (t) => {
    for (const o of ORDERING_VALUES) {
        t.is(lexCompareOrdering(-1 /* BEFORE */, o), -1 /* BEFORE */);
        t.is(lexCompareOrdering(1 /* AFTER */, o), 1 /* AFTER */);
    }
});
test("orderingInversion", (t) => {
    const len = ORDERING_VALUES.length;
    for (let i = 0; i < len; i++) {
        const evaluated = orderingInversion[ORDERING_VALUES[i]];
        const expected = ORDERING_VALUES[len - 1 - i];
        t.is(evaluated, expected);
    }
});
//# sourceMappingURL=ordering.test.js.map