"use strict";
/*
    Copyright (C) 2018  Victorien Elvinger

    This Source Code Form is subject to the terms of the Mozilla Public
    License, v. 2.0. If a copy of the MPL was not distributed with this
    file, You can obtain one at http://mozilla.org/MPL/2.0/.
*/
Object.defineProperty(exports, "__esModule", { value: true });
var flags_1 = require("../flags");
/**
 * @param test lazy test
 * @param msg reported message if {@link test } fails.
 */
function assert(test, msg) {
    if (flags_1.flags.assertionsEnabled && !test()) {
        if (flags_1.flags.failFastEnabled) {
            throw new Error(msg);
        }
        else {
            console.error("Assertion failed: " + msg);
        }
    }
}
exports.assert = assert;
/**
 * @param test lazy test which may be hurt the performance.
 * @param msg reported message if {@link test } fails.
 */
function heavyAssert(test, msg) {
    if (flags_1.flags.heavyAssertionsEnabled) {
        assert(test, msg);
    }
}
exports.heavyAssert = heavyAssert;
//# sourceMappingURL=assert.js.map