import { Concat } from "./concat";
import { u32 } from "../util/number";
/**
 * Model an insertion in a single-user list.
 */
export declare class Ins<E extends Concat<E>> {
    readonly index: u32;
    readonly content: E;
    /**
     * @param index Insertion index.
     * @param content Inserted elements.
     */
    constructor(index: u32, content: E);
    /**
     * Number of inserted elements.
     */
    readonly length: u32;
    endIndex(): u32;
}
/**
 * Model a removal in a single-user list.
 */
export declare class Del {
    readonly index: u32;
    readonly length: u32;
    /**
     * @param index Removal index.
     * @param items Number of removed elements.
     */
    constructor(index: u32, length: u32);
    endIndex(): u32;
}
