import { Ordering } from "./ordering";
export declare type u32 = number;
export declare type i32 = number;
export declare const U32_BOTTOM = 0;
export declare const U32_TOP = 4294967295;
/**
 * @param n
 * @return Is {@link n} an unsigned integer 32?
 */
export declare const isU32: (n: unknown) => n is number;
/**
 * @param n1
 * @param n2
 * @return Order relation between {@link n1} and {@link n2}.
 */
export declare function compareU32(n1: u32, n2: u32): Ordering;
/**
 * @param values
 * @return Non-cryptographic way to approximate identity of {@link values }.
 */
export declare const hashCodeOf: (values: readonly number[]) => number;
export declare const absoluteSubstraction: (a: number, b: number) => number;
